<template>
	<div class="ts-day">
		<div
			class="ts-date"
		>{{ formatDate(props.item.date) }} ({{ formatWeekDayShortcut(props.item.date) }})</div>
		<div class="ts-header ts-row">
			<div class="ts-col">Task</div>
			<div class="ts-col">Click</div>
			<div class="ts-col">RPTR</div>
			<div class="ts-col">RM</div>
		</div>
		<div class="ts-items">
			<div v-if="!hasData" class="ts-row ts-empty">
				<span>No data&nbsp;</span>
				<el-button type="primary" @click="handleClickupHoursClick(props.item.date)">Add</el-button>
			</div>
			<div v-else class="ts-item ts-row" v-for="item of items" :key="item.id">
				<div class="ts-col">
					<div class="ts-name">
						<input
							tabindex="-1"
							:value="item.taskName"
							@change="(e) => handleChangeName(e, item)"
							@keydown="handleKeyDown"
						/>
					</div>
					<el-tag @click="changeTaskId(item)">RM{{ item.redmineTaskId }}</el-tag>
					<el-tag @click="changeTaskId(item)" type="danger">IFS{{ item.ifsTaskId }}</el-tag>
				</div>
				<div
					class="ts-col"
					@click="handleClickupHoursClick(props.item.date)"
				>{{ formatHours(item.duration) }}</div>
				<div class="ts-col">
					<timesheet-hours-control
						:model-value="item.reportHours"
						:class="classByState(item.reportHoursChanged)"
						:plain="reportDisabled"
						@update:model-value="(hours) => updateReportHours(item, hours)"
						@reset="resetReportHours(item)"
					/>
				</div>
				<div class="ts-col">
					<timesheet-hours-control
						:model-value="item.redmineHours"
						:class="classByState(item.redmineHoursChanged)"
						@update:model-value="(hours) => updateRedmineHours(item, hours)"
						@reset="resetRedmineHours(item)"
					/>
				</div>
			</div>
		</div>
		<div v-if="hasData" class="ts-summaries">
			<div class="ts-summary ts-row">
				<div class="ts-col">Součet</div>
				<div class="ts-col">{{ formatHours(summaries.duration) }}</div>
				<div class="ts-col">{{ formatHours(summaries.reportHours) }}</div>
				<div class="ts-col">{{ formatHours(summaries.redmineHours) }}</div>
			</div>
			<div class="ts-attendance ts-row">
				<div class="ts-col">Rozdíl docházky</div>
				<div class="ts-col" v-html="printSubWithAttendance(item, summaries.duration)"></div>
				<div class="ts-col" v-html="printSubWithAttendance(item, summaries.reportHours)"></div>
				<div class="ts-col" v-html="printSubWithAttendance(item, summaries.redmineHours)"></div>
			</div>
			<div class="ts-summary ts-row">
				<div class="ts-col">Součet vykázáno</div>
				<div class="ts-col">{{ formatHours(summaries.duration) }}</div>
				<div class="ts-col">{{ formatHours(item.totalReportHours) }}</div>
				<div class="ts-col">{{ formatHours(item.totalRedmineHours) }}</div>
			</div>
			<div class="ts-attendance ts-row">
				<div class="ts-col">Rozdíl vykázáno</div>
				<div class="ts-col" v-html="printSubWithAttendance(item, summaries.duration)"></div>
				<div class="ts-col" v-html="printSubWithAttendance(item, item.totalReportHours)"></div>
				<div class="ts-col" v-html="printSubWithAttendance(item, item.totalRedmineHours)"></div>
			</div>
		</div>
	</div>
</template>
<script lang="ts" setup>
import { computed, ref, watch } from 'vue-demi';
import { addDuration, subDuration, DurationTime, formatDate, formatDuration, durationEquals, durationTotalHoursRounded, durationCompare, formatWeekDayShortcut } from '../../lib/utils';
import { ElTag, ElButton, ElMessage, ElMessageBox, ElDialog } from "element-plus";
import { TimesheetDayItem, TimesheetItem, TimesheetTask } from '../ts/types';
import TimesheetHoursControl from "./controls/TimesheetHoursControl.vue";
import { sumarizer, TimesheetType } from './timesheet';
import { showInDialog } from '../ts/utils';
import TimesheetDetailsVue from './TimesheetDetails.vue';


interface Props {
	colWidths: number[];
	item: TimesheetDayItem;
	teamId?: number;
}

interface UpdateTaskName {
	taskId: string;
	taskName: string;
}

type SummaryItem = Required<Pick<TimesheetItem, "duration" | "reportHours" | "redmineHours">>;

const defaultSummaries = (): SummaryItem => ({
	duration: DurationTime.zero(),
	reportHours: DurationTime.zero(),
	redmineHours: DurationTime.zero(),
});

const props = defineProps<Props>();
const emits = defineEmits<{
	(e: "changeTaskId", task: TimesheetTask): void
	(e: "changeTaskName", data: UpdateTaskName): void
	(e: "refresh"): void
}>();

const attendanceHours = computed(() => props.item.attendanceHours);
const items = computed(() => props.item.items);
const reportDisabled = computed(x => {
	console.log('state', props.item.reportState);
	return props.item.reportState !== "OPENED"
});

const hasData = computed(() => props.item.items.length > 0);

const summaries = ref(defaultSummaries());

recalcSummaries(items.value, "ALL");

watch([items, attendanceHours], ([newItem, newHours]) => {
	recalcSummaries(newItem, "ALL");
});

function classByState(changed: boolean) {
	return changed ? 'changed' : '';
}

function recalcSummaries(ts: TimesheetItem[], type: TimesheetType) {
	const sumDuration = sumarizer(x => x.id, x => x.duration);
	const sumReportHours = sumarizer(x => x.ifsTaskId, x => x.reportHours);
	const sumRedmineHours = sumarizer(x => x.redmineTaskId, x => x.redmineHours);

	const calcDuration = type === "ALL" || type === "CLICK";
	const calcReport = type === "ALL" || type === "RPTR";
	const calcRM = type === "ALL" || type === "RM";

	for (const item of ts) {
		if (calcDuration)
			sumDuration.add(item);

		if (calcReport)
			sumReportHours.add(item);

		if (calcRM)
			sumRedmineHours.add(item);
	}

	const {
		duration: oldDur, reportHours: oldReport, redmineHours: oldRM
	} = summaries.value;

	summaries.value = {
		duration: calcDuration ? sumDuration.result() : oldDur,
		reportHours: calcReport ? sumReportHours.result() : oldReport,
		redmineHours: calcRM ? sumRedmineHours.result() : oldRM,
	};
	// console.log("RECALC SUMMARIES", type);
}

function formatHours(hours: DurationTime | undefined) {
	return hours && durationTotalHoursRounded(hours) || '';
}

function changeTaskId(item: TimesheetItem) {
	if (!(item.taskId && item.taskName)) return;

	emits("changeTaskId", {
		id: item.taskId,
		name: item.taskName,
		ifsTaskId: item.ifsTaskId,
		redmineTaskId: item.redmineTaskId
	});
}

function printSubWithAttendance(itm: TimesheetDayItem, dur: DurationTime | undefined) {
	const { hours, minutes } = subDuration(dur, itm.attendanceHours);
	const sub = new DurationTime({ hours, minutes });
	const isZero = durationEquals(sub, DurationTime.zero());
	const className = sub.isNegative()
		? "negative"
		: isZero
			? "neutral"
			: "positive";

	return `<div class="${className}">${formatHours(isZero ? undefined : sub)}</div>`;
}

function handleChangeName({ target }: Event, item: TimesheetItem) {
	const input = target as HTMLInputElement;
	if (!(item.taskId)) return;

	emits("changeTaskName", {
		taskId: item.taskId,
		taskName: input.value,
	});
}

function handleKeyDown(e: KeyboardEvent) {
	if (e.key === "Enter") {
		const input = e.target as HTMLInputElement;
		input.blur();
	}
}

function handleClickupHoursClick(day: Date) {
	if (!props.teamId) {
		ElMessageBox.alert('Team is not selected.');
		return;
	}
	showInDialog({
		title: 'Clickup timesheets',
		width: 1000,
		height: 800,
	}, TimesheetDetailsVue, {
		teamId: props.teamId,
		day,
	})().then(x => refresh());
}

function refresh() {
	emits("refresh");
}

function updateRedmineHours(item: TimesheetItem, hours: DurationTime) {
	const ts = items.value;
	updateSameItems(
		ts,
		i => i.redmineTaskId === item.redmineTaskId,
		i => {
			i.redmineHours = hours;
			i.redmineHoursChanged = isChanged(hours, i.redmineHoursOld)
		}
	);
	recalcSummaries(ts, "RM");
}

function updateReportHours(item: TimesheetItem, hours: DurationTime) {
	const ts = items.value;
	updateSameItems(
		ts,
		i => i.ifsTaskId === item.ifsTaskId,
		i => {
			i.reportHours = hours;
			i.reportHoursChanged = isChanged(hours, i.reportHoursOld);
		}
	);
	recalcSummaries(ts, "RPTR");
}

function updateSameItems<T>(items: T[], equals: (itm: T) => boolean, update: (itm: T) => void) {
	for (const item of items) {
		if (equals(item)) {
			update(item);
		}
	}
}

function resetRedmineHours(item: TimesheetItem) {
	item.redmineHours = item.redmineHoursOld;
	item.redmineHoursChanged = false;
}

function resetReportHours(item: TimesheetItem) {
	item.reportHours = item.reportHoursOld;
	item.reportHoursChanged = false;
}

function isChanged(durNew: DurationTime, durOld: DurationTime | undefined): boolean {
	if (!durOld) {
		return durationCompare(durNew, DurationTime.zero()) > 0;
	}

	return !durationEquals(durNew, durOld);
}

</script>

<style lang="scss" scoped>
.ts-day {
	margin-bottom: 20px;
}

.el-tag {
	margin: 2px;
	cursor: pointer;
}

.ts-date {
	text-align: left;
	font-weight: bold;
}

.ts-header {
	font-weight: bold;
}

.ts-row {
	display: flex;
	justify-content: space-between;
	border-bottom: 1px solid #dcdfe6;
}

.ts-empty {
	color: red;
	justify-content: center;
	font-size: 30px;
}

.ts-summary,
.ts-attendance {
	background-color: #fad490;
	border: none;
}

.ts-attendance {
	::v-deep(.negative) {
		color: red;
	}

	::v-deep(.positive) {
		color: green;
	}
}

.ts-col {
	width: 110px;
	padding: 6px 3px;
	display: flex;
	justify-content: center;
	align-items: center;

	&:first-child {
		text-align: left;
		flex-grow: 1;
		display: flex;
	}
}

.ts-name {
	flex-grow: 1;

	input {
		width: 100%;
		padding: 8px 2px;
		border: 1px solid #dcdfe6;
	}
}

.ts-hours-control {
	&.changed {
		::v-deep(input) {
			background-color: #fad490;
		}
	}
}
</style>